#include <dos.h>

char kbhit(void) {
 asm push es;
 asm  mov ax,0;
 asm  mov es,ax;
 asm  mov al,es:[41ah];
 asm  mov ah,es:[41ch];
 asm pop es;
 asm cmp ah,al;
 asm jne KEYPRESSED;
 return 0x00;
KEYPRESSED:
 return 0x01;
}

void kbclear(void) {
asm push es;
asm  cli;
asm  sub ax,ax;
asm  mov es,ax;
asm  mov al,es:[41ah];
asm  mov es:[41ch],al;
asm  sti;
asm pop es;
}

int chrinstr (char c,char *str) {
 unsigned k;
 for (k=0; *(str+k); k++) if (*(str+k)==c) return (k);
 return (-1);
}

#define MAINDELAY 250
void beeps (char *notes) {
 unsigned octav[3][7]={ // , ࢠ,  ⠢
  {131,147,165,175,196,220,247},
  {262,294,330,349,392,440,494},
  {523,587,659,698,784,880,988}
 };
 unsigned diez[3][5]={ //    ⠢ (,,,᮫,)
  {139,156,185,208,233},
  {277,311,370,415,466},
  {554,622,740,830,932}
 };
 char *octav_str="asdfghj",       //祭   
      *diez_str="wetyu";          // ப ࠬ஢
 char oct=1,c,k;
 unsigned i,freq; int j;
 for (i=0; ; i++) {
  c=*(notes+i);
  if (c==0x00) { i=0; continue; } //!!!     
  if (c=='<') { if (oct) { oct--; continue; } }
  else if (c=='>') { if (oct<2) { oct++; continue; } }
  else if ((j=chrinstr (c,octav_str))!=-1) freq=octav[oct][j];
  else if ((j=chrinstr (c,diez_str))!=-1) freq=diez[oct][j];
  else freq=0;
  if (freq) {
   sound (freq);
   delay (MAINDELAY);
   nosound();
  }
  else delay (MAINDELAY);
  if (kbhit()) break;
 }
 kbclear(); delay (30);
 return;
}

void main (void) {
 // Fur Elise, L.V.Beethoven
 beeps("deded<j>sa<h-adhj-dyj>a-<d>deded<j>sa<h-"
 "<adhj-d>a<jh>deded<j>sa<h-adhj-dyj>a-<d>"
 "-deded<j>sa<h-<adhj>a<jh-j>asd<g>fds<f>d"
 "sa<d>sa<j-d>d--d-->d--<edededed<j>sa<h-a"
 "dhj-dyj>a-<d>deded<j>sa<h-adhj>a<jh>\0"
);
 // Santa Lucia 
 beeps("<g-g-->aa<jj---f-f--hhgg---d-h--ggtf---f-d-s-h-g---"
"g-g-->aa<jj---f-f--hhgg---d-h--ggtf---f-d-s-h-g--->"
"d-s-a-<jh>s---s-a-<j-tg>a---daa<ggdf>ss---s-<h--j>s-a-"
"d-s-a-<jh>s---s-a-<j-tg>a---daa<ggdf>ss---s-d--ss-a---\0"
);
 // ᪮ 
 beeps("<dgjgh-gtj-h-d--gj>ssd-sa<j-->w-e-td<j--tdjh>a--"
"sa<j-hgj-h-d-j->w-e-td<j--tdjh>a--sa<j-hgj-h->d--\0"
);
 // Grande Valse brillante, F.Chopin
 beeps("<u->sef-<u->efg-<u->fgy-u--uu>a-<uy-y-uyg-g-ygf-f-gfe-"
"<u->sef-<u->efg-<u->fgy-u--usuw-u>a<uy-<j->yuyg-<u->gygf-e-uuuu"
"<u->sef-<u->efg-<u->fgy-u--uu>a-<uy-y-uyg-g-ygf-f-gfe-"
"<u->sef-<u->efg-<u->fgy-u--usuw-u>a<uy-<j->yuyg-<u->gygf-e-eeee"
"eeeeeefea<yedffffffey>aeydfffffffgfey>a-f-ew<g-u-yea-"
"eeeeeefea<yedffffffey>aeydfffffffgfey>a-f-ew<g-y--a-\0"
);
 // Valse op7, F.Chopin
 beeps("a-a-wa<uyg--ff->f-<u>aeww--aa-<j>awafgy<y>dgf<f>aew<w>a<u"
"g>a<j>awse-fewa<u--yy->y-aegfe--ss>a--<uhy-ygfesaa<uhu>a<u"
">a<uhu>a<uu->>a<uhytgse<e>a<y<y>gufue-->w\0"
);
 // 檮 ஭, ..
 beeps("<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<h>a<jhghjhghjhgtd---"
"<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<h>a<jhghjhghjhgtd---"
"dfgghgfds<g>dfgghgfds-asddfdsa<jd>asddfdsa<j-"
"<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<hj>a<jhyhdfsa-<j-h-"
">dfgghgfds<g>dfgghgfds-asddfdsa<jd>asddfdsa<j-"
"<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<hj>a<jhyhdfsa-<j-h-"
">hj>w-<hj>w<jhytyhjtdhj>w-<hj>w<jhytjydh--"
"hj>w-<hj>w<jhytyhjtdhj>w-<hj>w<jhytjydh--\0"
);
 return;
}